import lgr
import sk_lgr
import sk_gnb
import parser
import numpy as np
import matplotlib.pyplot as plt

sizes = [.1,.2,.3,.4,.5,.6,.7,.8,.9,1.0]

def setup_data(filename):
    """ Setup training dataset

        Returns tuple of length 2: (X_train, y_train)
        where X_train is an Nx2 ndarray and y_train is an Nx1 ndarry.
    """
    X_train = []
    y_train = []

    file = open(filename,'r')
    lines = file.readlines()
    for line in lines:
        line = line[0:len(line)-1]
        data = list(line.split(","))
        y_train.append([float(data[len(data)-1])])
        data = parser.line_reader(data[0:len(data)-1])
        X_train.append(data)
    
    return (X_train, y_train)

def test_logistic(training_filename,testing_filename):

	(X_train,y_train) = setup_data(training_filename)
	weights = [0]*(len(X_train[0]))
	weights = np.array(weights)
	weights = weights.reshape((len(weights),1))
	X_train=np.array(X_train)
	y_train = np.array(y_train)
	weights = (alt_regression.gradient_descent(X_train,y_train,0,.25,weights,20))
	weights = weights[len(weights)-1]

	cnt = 0
	file = open(testing_filename,'r')
	lines = file.readlines()
	y_test = []
	X_test = []
	for line in lines:
	    line = line[0:len(line)-1]
	    data = list(line.split(","))
	    y_test.append([float(data[len(data)-1])])
	    data = parser.line_reader(data[0:len(data)-1])
	    X_test.append(data)
	y_test = np.array(y_test)
	X_test = np.array(X_test)


def test_parser():
	X,y = parser.file_reader("data/training_set.txt")
	f = open("parserX_grade.txt","w+")
	for i in range(0,len(X)):
		for j in range(0,len(X[i])):
			f.write("%s," % X[i][j])
		f.write("%s" % y[i])
		f.write("\n")

	X_test,y_test = parser.file_reader("data/training_set.txt")
	f.close()

	X_sol = []
	y_sol = []
	file = open("parserX_grade.txt",'r')
	lines = file.readlines()
	for i in range(0,len(lines)):
		line = lines[i]
		line = line[0:len(line)-1]
		data = np.array(list(line.split(",")))
		y_sol.append(float(data[len(data)-1]))
		data = data[0:len(data)-1]
		X_sol.append(data.astype(np.float))

	X_sol = np.array(X_sol)
	y_sol = np.array(y_sol)

	for i in range(0,len(X_test)):
		for j in range(0,len(X_test[i])):
			if(X_sol[i][j] != X_test[i][j]):
				print("Parsing Error")
		if(y_sol[i] != y_test[i]):
			print("Parsing error")


def test_gnb(training_filename,testing_filename):
	
	test_accs = []
	train_accs = []
	for i in range(0,len(sizes)):
		(test_acc,train_acc) = sk_gnb.gnb(training_filename,testing_filename,data_size=sizes[i])
		test_accs.append(test_acc)
		train_accs.append(train_acc)
	return (test_accs,train_accs)

def test_lr(training_filename,testing_filename):
	test_accs = []
	train_accs = []
	for i in range(0,len(sizes)):
		(test_acc,train_acc) = sk_lgr.lgr(training_filename,testing_filename,data_size=sizes[i])
		test_accs.append(test_acc)
		train_accs.append(train_acc)
	return (test_accs,train_accs)


test_parser()

